<?php
/**
* Generates Calendar
* PHP Calendar (version 2.3), written by Keith Devens
* http://keithdevens.com/software/php_calendar
* see example at http://keithdevens.com/weblog
* License: http://keithdevens.com/software/license
* Lots of changes by Reigo Reinmets reigo (dot) reinmets (at) hot (dot) ee
*/
function generate_calendar($year, $month, $days = array(), $day_name_length = 3, $month_href = NULL, $first_day = 1, $Links = array())
{
	$first_of_month = gmmktime(0,0,0,$month,1,$year);
	$day_names = array(); #generate all the day names according to the current locale
	for($n=0,$t=(3+$first_day)*86400; $n<7; $n++,$t+=86400) #January 4, 1970 was a Sunday
		$day_names[$n] = ucfirst(gmstrftime('%A',$t)); #%A means full textual day name

	list($month, $year, $month_name, $weekday) = explode(',',gmstrftime('%m,%Y,%B,%w',$first_of_month));
	$weekday = ($weekday + 7 - $first_day) % 7; #adjust for $first_day

	@list($ly, $lyl) = each($Links); // last year
	@list($p, $pl) = each($Links); // previous
	@list($n, $nl) = each($Links); // next
	@list($ny, $nyl) = each($Links); // next year
	$ly = '<a href="'.htmlspecialchars($lyl).'">'.$ly.'</a>';
	$p = '<a href="'.htmlspecialchars($pl).'">'.$p.'</a>';
	$n = '<a href="'.htmlspecialchars($nl).'">'.$n.'</a>';
	$ny = '<a href="'.htmlspecialchars($nyl).'">'.$ny.'</a>';

	$calendar = '<table class="green" width="100%">'."\n".
		'<tr><th colspan="7" style="text-align: center;">'.
		$ly.'&nbsp;&nbsp;'.$p.'&nbsp;'.
		htmlentities(ucfirst(t($month_name))).'&nbsp;'.$year.
		'&nbsp;'.$n.'&nbsp;&nbsp;'.$ny.
		"</th></tr><tr>";

	if($day_name_length)
	{ 
		#if the day names should be shown ($day_name_length > 0)
		#if day_name_length is >3, the full name of the day will be printed
		foreach($day_names as $d)
		{
			$calendar .= '<th>'.htmlentities(localize(substr($d,0,$day_name_length))).'</th>';
		}
		$calendar .= "</tr>\n<tr>";
	}

	if($weekday > 0) $calendar .= '<td colspan="'.$weekday.'">&nbsp;</td>'; #initial 'empty' days
	for($day=1,$days_in_month=gmdate('t',$first_of_month); $day<=$days_in_month; $day++,$weekday++)
	{
		if($weekday == 7)
		{
			$weekday   = 0; #start a new week
			$calendar .= "</tr>\n<tr>";
		}
		if(isset($days[$day]) and is_array($days[$day]))
		{
			@list($link, $classes, $content) = $days[$day];
			if(is_null($content))
			{
				$content  = $day;
			}
			$calendar .= '<td'.($classes ? ' class="'.htmlspecialchars($classes).'">' : '>').($link ? '<a href="'.htmlspecialchars($link).'">'.$content.'</a>' : $content).'</td>';
		}
		else
		{
			$calendar .= "<td>$day</td>";
		}
	}
	if($weekday != 7)
	{
		$calendar .= '<td colspan="'.(7-$weekday).'">&nbsp;</td>'; #remaining "empty" days
	}
	return $calendar."</tr>\n</table>\n";
}
/*
*
*/
class Calendar extends TWebControl
{
	public function __construct()
	{
		$year = $this->Module->Year;
		$month = $this->Module->Month;
		$day = $this->Module->Day;
		$prev=$this->prevMonth($year, $month, $day);
		$next=$this->nextMonth($year, $month, $day);
		$days = $this->generateDays($year, $month, $day);
		$pn = array(
			localize('&laquo;&laquo;')=>$this->Request->constructUrl(array(array('Date'=>($year-1).'-'.$month.'-'.$day))),
			localize('&laquo;')=>$this->Request->constructUrl(array(array('Date'=>$prev))),
			localize('&raquo;')=>$this->Request->constructUrl(array(array('Date'=>$next))),
			localize('&raquo;&raquo;')=>$this->Request->constructUrl(array('Date'=>($year+1).'-'.$month.'-'.$day)),
			);
			$this->set('calendar',$this->generate_calendar($year, $month, $days, 3, NULL, 1, $pn));
	}
	/*
	*
	*/
	function generateDays($year, $month, $day)
	{
		$uri = $this->Module->getUserReferer();
		for ($i=0; $i<=31;$i++) 
		{
			$k = (strlen($i) == 1) ? '0'.$i : $i;
			if ($i == $day) 
			{
				$days[$i] = array($this->Request->constructUrl($this->Request->getRequestedPage(),array_merge($uri,array('Date'=>$year."-".$month."-".$i))),NULL,'<span style="color: red; font-weight: bold;">'.$k.'</span>');
			}
			else 
			{
				$days[$i] = array($this->Request->constructUrl($this->Request->getRequestedPage(),array_merge($uri,array('Date'=>$year."-".$month."-".$i))),NULL,$k);
			}
		}
		return $days;
	}
	/*
	*
	*/
	public function nextMonth($year, $month, $day) 
	{
		if ($month == 12) 
		{ 
			$year++; $month=1; 
		} 
		else 
		{ 
			$month++; 
		}
		return $year."-".$month."-".$day;
	}
	/*
	*
	*/
	public function prevMonth($year, $month, $day) 
	{
		if ($month == 1) 
		{ 
			$year--; $month=12; 
		} 
		else 
		{ 
			$month--; 
		}
		return $year."-".$month."-".$day;
	}
}
?>